#!/usr/bin/perl -w
#
# oppBanish 1.4.7 for IPCop 1.9.x based Banish 1.4.7 IP Sort & iptables reload
#
# Sort the IP address on the oppBanish list,
# write sorted IPs back to the oppBanish list
# and reload iptables

# List of banished IPS/networks
$filename = "/var/ipcop/oppBanish/ip_oppBanishlist";

# Open Banish list file and read in contents
open(INFILE, $filename) or die 'Unable to open Banish list file.';
@in = <INFILE>;
close(INFILE);

# Sort IPs
@out = sort {

    pack('C4' => $a =~

      /(\d+)\.(\d+)\.(\d+)\.(\d+)/)

    cmp

    pack('C4' => $b =~

      /(\d+)\.(\d+)\.(\d+)\.(\d+)/)

  } @in;

# Write sorted list to Banish list file
open(OUTFILE, ">$filename") or die 'Unable to open Banish list file.';
flock OUTFILE, 2;
	foreach $line (@out)
	{
		print OUTFILE "$line";
	};
close(OUTFILE);

# Reload iptables rules
exec('/etc/rc.d/rc.oppBanish reload');
